function loadResources()
    local resource = struct('w', 'h', 'visual', 'tier')
    cost_tiers = {{3, 3}, {5, 5}, {10, 10}, {15, 15}, {15, 30}, {30, 30}, {30, 50}, {50, 50}}
    -- Tiers:
    -- 1 -> 3
    -- 2 -> 5
    -- 3 -> 10
    -- 4 -> 15
    -- 5 -> 15-30
    -- 6 -> 30
    -- 7 -> 30-50
    -- 8 -> 50
    resources = {}
    resources['Heart'] = resource(20, 20, heart_32, 2)
    resources['HalfHeart'] = resource(20, 20, half_heart_32, 1)
    resources['BronzeCoin'] = resource(12, 12, bronze_coin_16)
    resources['Mask'] = resource(24, 24, mask_32, 2)
    resources['HalfMask'] = resource(24, 24, half_mask_32, 1)
    resources['Chest'] = resource(24, 24, chest_closed, 3)
    resources['Surprise'] = resource(36, 36, surprise, 4)
    resources['Bomb'] = resource(20, 20, bomb, 4)

    resources['Water Automaton'] = resource(24, 24, tower_blue, 6)
    resources['Air Automaton'] = resource(24, 24, tower_yellow, 6)
    resources['Fire Automaton'] = resource(24, 24, tower_red, 6)
    resources['Earth Automaton'] = resource(24, 24, tower_green, 6)
    resources['ASPD'] = resource(24, 24, aspd, 6)
    resources['Fitter, Happier'] = resource(22, 22, fitter_happier, 7)
    resources['HL3'] = resource(24, 24, hl3, 5)
    resources['Ricochet'] = resource(34, 34, ricochet, 5)
    resources['Kiri kiri kiri'] = resource(22, 22, kiri, 5)
    resources['The Scout'] = resource(18, 38, scout, 5)
    resources['The Tom Cruise'] = resource(54, 70, tom_cruise, 5)
    resources['The Michael Bay'] = resource(40, 46, michael_bay, 5)
    resources['King of Loss'] = resource(40, 20, crown, 1)
    resources['Gentle Giant'] = resource(40, 32, giant, 7)
    resources['Genius, Billionaire, Playboy, Philanthropist'] = resource(30, 40, iron_man, 1)
    resources['Gun Kata'] = resource(24, 24, gun_kata, 5)
    resources['Thick Skin'] = resource(50, 56, thick_skin, 7)
    resources['Wildfire'] = resource(40, 40, wildfire, 4)
    resources["JUMP'NSHOOTMAN"] = resource(48, 52, jumpnshootman, 5)
    resources["DASH'NSHOOTMAN"] = resource(80, 36, dashnshootman, 5)
    resources["MOV'NSHOOTMAN"] = resource(50, 46, movnshootman, 4)
    resources['Rainbow Dash'] = resource(80, 36, rainbow_dash, 5)
    resources['Resonance Cascade'] = resource(24, 24, resonance, 8)
    resources['Mutant Spider'] = resource(40, 40, mutantspider, 8)
    resources['Egg Bomb Launcher'] = resource(24, 18, eggbomb, 7)
    resources['Sludge Bomb'] = resource(20, 18, sludge, 6)
    resources['Psyburst'] = resource(30, 30, psy, 6)
    resources['Ember'] = resource(24, 24, ember, 6)
    resources['Razor Leaf'] = resource(12, 12, leaf, 6)
    resources['Rock Throw'] = resource(24, 24, rock, 6)
    resources['The Joker'] = resource(36, 20, flaria, 3)
    resources["Anivia's R"] = resource(20, 20, anivia, 3)
    resources['The Salamanca!'] = resource(24, 38, salamanca, 3)
    resources['Spider Butt'] = resource(40, 40, spiderbutt, 3)
    resources['The Dead Ringer'] = resource(18, 38, spy, 3)
    resources['Invis Watch'] = resource(18, 38, spy, 3)
    resources['Bicurious'] = resource(16, 28, bicurious_right, 5)
    resources['A Friend'] = resource(16, 28, a_friend_right, 5)
    resources['A Better Friend'] = resource(16, 28, a_better_friend_right, 5)
    resources['Flaria'] = resource(16, 28, flaria, 5)
    resources['Bubblebeam'] = resource(24, 24, bubble, 6)
    resources['The Pentagram'] = resource(24, 24, pentagram, 6)
    resources["Legolas' Bow"] = resource(24, 24, bow_1, 5)
    resources["Marle's Pendant"] = resource(24, 24, pendant, 5)
    resources["Ayla's Necklace"] = resource(24, 24, necklace, 6)
    resources['Not Masamune'] = resource(24, 24, sword, 5)
    resources['Waterbending = Healing'] = resource(24, 24, heal, 5)
    resources["Everything's Okay"] = resource(24, 24, vial, 5)
    resources["Gangplank's Soul"] = resource(24, 24, gold_sword, 3)
    resources['Starshooter'] = resource(24, 24, bow_2, 6)
    resources['Equilibrium Spear'] = resource(24, 24, earth_spear, 5)
    resources['Grog Soaked Spear'] = resource(24, 24, poisoned_spear, 5)
    resources['Enchanted Crystal Spear'] = resource(24, 24, ice_spear, 5)
    resources['Impervius'] = resource(24, 24, impervius, 5)
    resources['Chronomage'] = resource(24, 24, chronomage, 8)
    resources['Double Damage'] = resource(24, 24, ddamage, 3)
    resources['Double Defense'] = resource(24, 24, ddefense, 3)
    resources['Apple'] = resource(24, 24, apple, 5)
    resources['Banana'] = resource(24, 24, banana, 5)
    resources['Bread'] = resource(24, 20, bread, 5)
    resources['Carrot'] = resource(24, 24, carrot, 5)
    resources['Cheese'] = resource(24, 24, cheese, 5)
    resources['Egg'] = resource(24, 18, egg, 5)
    resources['Cherry'] = resource(24, 24, cherry, 5)
    resources['Fish'] = resource(22, 18, fish, 6)
    resources['Meat'] = resource(24, 20, meat, 6)
    resources['Orange'] = resource(24, 24, orange, 5)
    resources['Pie'] = resource(24, 18, pie, 6)
    resources['Watermelon'] = resource(24, 24, watermelon, 5)
    resources['Cannon Barrage'] = resource(24, 24, cannon, 5)
    resources["Jack Sparrow's Heart"] = resource(24, 18, chest_p, 5)
    resources["Charon's Obol"] = resource(24, 24, goldcoin, 5)
    resources['My Reflection'] = resource(24, 24, mirror, 5)
    resources['Ninja Assassin'] = resource(24, 18, daggers, 5)
    resources['Rains of Castamere'] = resource(24, 24, arrow, 6)
    resources['Rare Candy'] = resource(30, 30, candy, 7)
    resources['Through the Fire and Flames'] = resource(24, 24, death1, 3)
    resources['Love'] = resource(24, 24, heart_p, 5)
    resources['Book #1'] = resource(20, 24, book_gray, 5)
    resources['Book #2'] = resource(20, 24, book_attack, 5)
    resources['Book #3'] = resource(20, 24, book_holy, 5)
    resources['Book #4'] = resource(20, 24, book_hell, 5)
    resources['Book #5'] = resource(20, 24, book_glass, 5)
    resources['Book #6'] = resource(20, 24, book_blue, 5)
    resources['Book #7'] = resource(20, 24, book_pink, 5)
    resources['Green Potion'] = resource(16, 26, potion_green_big, 3)
    resources['Blue Potion'] = resource(16, 26, potion_blue_big, 3)
    resources['Orange Potion'] = resource(16, 26, potion_orange_big, 3)
    resources['Red Potion'] = resource(16, 26, potion_red_big, 3)
    resources['White Potion'] = resource(16, 26, potion_white_big, 3)
    resources['Yellow Potion'] = resource(16, 26, potion_yellow_big, 3)
    resources['Pink Potion'] = resource(16, 26, potion_pink_big, 3)
end
